unit Unit1;

interface

uses Windows,SysUtils,Forms,Classes,Controls,Graphics,StdCtrls,Spin;

const
  _n=#13#10;
  _s='   ';
  cap=_s+'Comb.Generator [0.6] by Markus_13';
  tx='.txt';

type
  Tf = class(TForm)
    o: TMemo;
    s1: TSpinEdit;
    s2: TSpinEdit;
    b1: TButton;
    b2: TButton;
    al: TEdit;
    pr: TLabel;
    am: TMemo;
    procedure btnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
  public
  end;
outproc=procedure(s:string);

var
  f:Tf;
  ou:textFile;
  sc:int64;

implementation

function gExe:string;
begin
  result:=paramStr(0);
end;

function pow(n:integer;s:word):int64;
var k:word;
begin
  result:=1;
  for k:=1 to s do result:=result*n;
end;

function fac(n:word):extended;
var k:word;
begin
  result:=0.001;
  for k:=1 to n do result:=result*k;
end;

function chkRepeatChrz(s:string):boolean;
var x,y,z:cardinal;
begin
  result:=false;
  z:=length(s);
  for x:=1 to z do begin
    for y:=1 to z do begin
      if(x=y)then continue;
      if(s[x]=s[y])then begin
        result:=true;
        break;
      end;
    end;
    if result then break;
  end;
end;

//,.,..,_,?(_),...
procedure genWordZ(alph:shortstring;min,max:byte;p:outproc;unic:boolean=false;cnt:byte=1;buf:string='');
var k:byte;
begin
  for k:=1 to length(alph)do begin
    setlength(buf,cnt);
    buf[cnt]:=alph[k];
    if(cnt>=min)then begin
      if(unic)then begin
        if not chkRepeatChrz(buf)then p(buf);
      end else p(buf);
    end;
    if(cnt<max)then genWordZ(alph,min,max,p,unic,cnt+1,buf);
  end;
end;

//-_.,.,..,_,?(_),...
procedure genWordZz(alph:tStrings;min,max:byte;p:outproc;unic:boolean=false;cnt:byte=1;buf:string='');
var k,n:byte;bu2:string;
begin
  for k:=1 to alph.Count do begin
    setlength(buf,cnt);
    buf[cnt]:=chr(k);
    if(cnt>=min)then begin
      bu2:='';
      for n:=1 to cnt do begin
        bu2:=bu2+alph.Strings[ord(buf[n])-1];
      end;
      if(unic)then begin
        if not chkRepeatChrz(buf)then p(bu2);
      end else p(bu2);
    end;
    if(cnt<max)then genWordZz(alph,min,max,p,unic,cnt+1,buf);
  end;
end;

{$R *.dfm}

procedure write2txt(s:string);
begin
  inc(sc);
  writeln(ou,s);
  if(sc mod 1000=0)then try with f do begin
    pr.Caption:=inttostr(sc)+_n+' / '+_n+pr.Hint;
    application.ProcessMessages;
  end;except f.pr.Caption:='error';end;
end;

procedure Tf.btnClick(Sender: TObject);
var
  a:shortstring;
  k,n,m:byte;
  procedure endWork;
  begin
    enabled:=true;
    o.Show;
    o.SelStart:=length(o.Text);
    o.SelLength:=0;
    o.SetFocus;
  end;
begin
  s1.Update;
  s2.Update;
  enabled:=false;
  o.Hide;
  o.Lines.Clear;
  n:=s1.Value;
  m:=s2.Value;
  if(length(al.Text)>n)then begin
    n:=length(al.Text);
    s1.Value:=n;
  end;
  if(length(am.Text)>2)then begin
    n:=am.Lines.Count;
    s1.Value:=n;
    al.Text:='';
  end else if(length(al.Text)<n)then begin//alphabet generation>>>
    al.Text:='';
    for k:=0 to n-1 do al.Text:=al.Text+chr(ord('A')+k);
  end;
  sc:=0;
  pr.Caption:='';
  if(sender=b2)and(m>n)then begin//if alphabet < word_length
    o.Lines.Add(s2.Hint+' can`t be > than '+s1.Hint);
    endWork;
    exit;
  end;
  try
    if sender=b1 then a:=inttostr(pow(n,m));//formula_1
    if sender=b2 then a:=inttostr(round(fac(n)/fac(n-m)));//formula_2
  except a:='?';end;
  pr.Hint:=a;
  assignFile(ou,gExe+tx);
  rewrite(ou);
  if al.Text='' then genWordZz(am.Lines,m,m,write2txt,sender=b2)
    else genWordZ(al.Text,m,m,write2txt,sender=b2);
  closeFile(ou);
  if(sc>999999)then begin
    o.Lines.Add('sry... :( File too big ):');
    o.Lines.Add(gExe+tx);
  end else o.Lines.LoadFromFile(gExe+tx);
  o.Lines.Add('Exact number: '+inttostr(sc));
  o.Lines.Add('By formula: '+a);
  endWork;
end;

procedure Tf.FormCreate(Sender: TObject);
begin
  if FindWindow('Tf',cap)>0 then halt;
  caption:=cap;
  font:=screen.MenuFont;
  font.Color:=clBtnText;
  color:=clBtnFace;
end;

end.
